﻿// -----------------------------------------------------------------------
// <copyright file="Pageable.cs" company="Spardo, LLC">
// Copyright (c) 2011 SPardo, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this software and associated documentation files (the "Software"), 
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the 
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
// </copyright>
// -----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace BBYOpen.Linq
{
    [DataContract]
    public class Pageable<T> : Pageable, IEnumerable<T>
    {
        [DataMember(Name = "resultList")]
        public IEnumerable<T> ResultList { get; set; }

        public IEnumerator<T> GetEnumerator()
        {
            return this.ResultList.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.ResultList.GetEnumerator();
        }
    }

    [DataContract]
    public class Pageable
    {
        [DataMember(Name = "queryTime")]
        public decimal QueryTime { get; set; }
        [DataMember(Name = "currentPage")]
        public int CurrentPage { get; set; }
        [DataMember(Name = "totalPages")]
        public int TotalPages { get; set; }
        [DataMember(Name = "partial")]
        public bool Partial { get; set; }
        [DataMember(Name = "from")]
        public int From { get; set; }
        [DataMember(Name = "total")]
        public int Total { get; set; }
        [DataMember(Name = "to")]
        public int To { get; set; }
        [DataMember(Name = "canonicalUrl")]
        public string CanonicalUrl { get; set; }
        [DataMember(Name = "totalTime")]
        public decimal TotalTime { get; set; }
    }
}
