﻿// -----------------------------------------------------------------------
// <copyright file="DiagnosticExtensions.cs" company="Spardo, LLC">
// Copyright (c) 2011 SPardo, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this software and associated documentation files (the "Software"), 
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the 
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
// </copyright>
// -----------------------------------------------------------------------

using System;

public static class DiagnosticExtensions
{
    public static T ToDebug<T>(this T entity)
    { 
        string message = string.Empty;
        if (entity != null)
            message = entity.ToString();
        return ToDebug(entity, message);
    }

    public static T ToDebug<T>(this T entity, string message)
    {
#if DEBUG
        System.Diagnostics.Debug.WriteLine(string.Format("{0} [{1}] - {2}"
            , DateTime.Now
            , (entity != null) ? entity.GetType().Name : "NULL OBJECT"
            , message));
#endif
        return entity;
    }
}

