﻿// -----------------------------------------------------------------------
// <copyright file="RemixQueryContext.cs" company="Spardo, LLC">
// Copyright (c) 2011 SPardo, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this software and associated documentation files (the "Software"), 
// to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense, 
// and/or sell copies of the Software, and to permit persons to whom the 
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
// </copyright>
// -----------------------------------------------------------------------

namespace BBYOpen.Linq
{
    using System.Linq;
    using BBYOpen.Linq.Models;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class RemixQueryContext
    {
        public string ApiKey { get; private set; }

        public RemixQueryContext(string apiKey)
        {
            this.ApiKey = apiKey;
        }

        internal IQueryable<T> Query<T>() where T : IRemixItem
        {
            return new RemixQueryable<T>(this.ApiKey);
        }

        public IQueryable<Category> Categories { get { return this.Query<Category>(); } }

        public IQueryable<Product> Products { get { return this.Query<Product>(); } }

        public IQueryable<Store> Stores { get { return this.Query<Store>(); } }

        public IQueryable<Review> Reviews { get { return this.Query<Review>(); } }
    }
}
